#include "cellWidget.h"
#include <QGraphicsRectItem>
#include <QGridLayout>
#include <QDebug>
#include <QApplication>
#include <QDesktopWidget>
#include <QResizeEvent>

cellWidget::cellWidget(QWidget *parent) : QWidget(parent), m_settings("Fols", "MineSweeper")
{
    //microsoft minesweeper minimal size 220 x 220
    //m_wgtMinWidth = 220;
    //m_wgtMinHeight = 240;
    m_cellSize = 20;

    //create widget
    //resize(m_wgtMinWidth, m_wgtMinWidth);
    setMinimumSize(220, 230);

    setLayout(new QGridLayout);
    screen = new QGraphicsView();
    layout()->addWidget(screen);
    screen->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    screen->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);

    qDebug() << width() << " " << height();
    m_scene = new QGraphicsScene();
    m_scene->setSceneRect(0, 0, 220, 240);
    m_scene->setBackgroundBrush(Qt::gray);
    screen->setScene(m_scene);

    readSettings();
    createCellArea(m_cellNumbersX, m_cellNumbersY);
}

void cellWidget::createCellArea(int width, int height)
{
    qDebug() << "SceneRect: " << m_scene->width();
    qDebug() << "SceneRect: " << m_scene->height();
//    QDesktopWidget *pWgt = QApplication::desktop();
    //uint cellSiZe = pWgt->screenGeometry(0).width();
    int posX = 0, posY = 0;
    for(int i(0); i < width; ++i)
    {
        posY = 0;
        for(int j(0); j < height; ++j)
        {
            MCell *cell = new MCell(this);
            cell->setCellSize(m_cellSize);
            cells.append(cell);
            m_scene->addItem(cell);
            cell->setPos(posX, posY);
            posY += m_cellSize;
        }
        posX += m_cellSize;
    }
}

//program settings block begin
void cellWidget::writeSettings()
{
    m_settings.beginGroup("/Options");
    m_settings.setValue("/cellNumbersX", m_cellNumbersX);
    m_settings.setValue("/cellNumbersY", m_cellNumbersY);
    m_settings.endGroup();
}

void cellWidget::readSettings()
{
    m_settings.beginGroup("/Options");
    uint cellNumbersX = m_settings.value("/cellNumbersX", 9).toInt();
    uint cellNumbersY = m_settings.value("/cellNumbersY", 9).toInt();
    m_cellNumbersX = cellNumbersX;
    m_cellNumbersY = cellNumbersY;
    m_settings.endGroup();
}
//program settings block end


void cellWidget::resizeEvent(QResizeEvent *)
{
    //need max size of rect
    //QDesktopWidget *pWgt = QApplication::desktop();
    //uint rectMaxSize = (pWgt->screenGeometry(0).width() - 400);

    //viewArea = m_scene->itemsBoundingRect();
    //screen->fitInView(viewArea, Qt::KeepAspectRatio);
    //screen->centerOn(0, 0);

    //qDebug() << "Viewarea size: " << viewArea.size();

}

cellWidget::~cellWidget()
{
    writeSettings();
}
