#ifndef WIDGET_H
#define WIDGET_H

#include <QWidget>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QGraphicsEllipseItem>
#include <QSettings>
#include "mcell.h"

class cellWidget : public QWidget
{
    Q_OBJECT

public:
    explicit cellWidget(QWidget *parent = 0);
    void createCellArea(int, int);
    void repaintArea();
    void writeSettings();
    void readSettings();
    ~cellWidget();

protected:
    void resizeEvent(QResizeEvent *);

private:
    QGraphicsScene *m_scene;
    QGraphicsView *screen;
    QGraphicsEllipseItem *m_elipse;
    QVector<MCell*> cells;



    uint m_wgtMinWidth;
    uint m_wgtMinHeight;
    uint m_cellNumbersX;
    uint m_cellNumbersY;
    double m_cellSize;
    QRectF viewArea;
    QSettings m_settings;
};

#endif // WIDGET_H
