#include "mainwindow.h"
#include <QAction>
#include <QMenu>
#include <QMenuBar>
#include <QApplication>

mainWindow::mainWindow(QWidget *pwgt) : QMainWindow(pwgt)
{
    m_mcellWgt = new cellWidget;
    createActions();
    createMenus();
    setCentralWidget(m_mcellWgt);
    resize(220, 240);
}

void mainWindow::slotNewGame()
{

}

void mainWindow::slotAbout()
{

}

void mainWindow::slotGameOptions()
{

}

void mainWindow::resizeEvent(QResizeEvent *)
{
    if (width() > 220)
    {
        resize(width(), width());

    }
    if (height() > 245)
    {
        resize(height(), height());
    }
}



void mainWindow::createMenus()
{
    mainMenu = new QMenu(tr("&Game"));
    aboutMenu = new QMenu(tr("&About"));

    mainMenu->addAction(m_newGameAct);
    mainMenu->addAction(m_gameOptionsAct);
    mainMenu->addSeparator();
    mainMenu->addAction(m_closeAct);

    aboutMenu->addAction(m_aboutAct);

    menuBar()->addMenu(mainMenu);
    menuBar()->addMenu(aboutMenu);
}

void mainWindow::createActions()
{
    m_newGameAct = new QAction(QIcon(":/new/images/resource/newGame.ico"), tr("&New Game"), this);
    connect(m_newGameAct, &QAction::triggered, this, &mainWindow::slotNewGame);

    m_gameOptionsAct = new QAction(QIcon(":/new/images/resource/gameOptions.ico"), tr("Game options"), this);
    connect(m_gameOptionsAct, &QAction::triggered, this, &mainWindow::slotGameOptions);

    m_aboutAct = new QAction(QIcon(":/new/images/resource/about.ico"), tr("About"), this);
    connect(m_aboutAct, &QAction::triggered, this, &mainWindow::slotAbout);

    m_closeAct = new QAction(QIcon(":/new/images/resource/close.ico"), tr("Exit"), this);
    connect(m_closeAct, &QAction::triggered, this, &mainWindow::close);
}

