#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "cellWidget.h"

class QAction;
class QPopupMenu;
class QMenu;

class mainWindow : public QMainWindow

{
    Q_OBJECT

public:

   explicit mainWindow(QWidget *pwgt = 0);

public slots:
    void slotNewGame();
    void slotAbout();
    void slotGameOptions();

protected:
    void resizeEvent(QResizeEvent *);

private:
    cellWidget *m_mcellWgt;

    void createMenus();
    void createActions();

    //QActions
    QAction *m_newGameAct;
    QAction *m_aboutAct;
    QAction *m_gameOptionsAct;
    QAction *m_closeAct;

    QMenu *mainMenu;
    QMenu *aboutMenu;

};

#endif // MAINWINDOW_H
