#ifndef MCELL_H
#define MCELL_H

#include <QGraphicsItem>
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <windows.h>

enum State { eClosed, eOpen, eQuestion, eFlag, eDigit };

class QBrush;

class MCell : public QObject, public QGraphicsItem
{
    Q_OBJECT

public:
    explicit MCell(QObject *parent = 0);
    uint getAreaXSize();
    uint getAreaYSize();
    uint getCellSize();
    void setCellSize(uint size);
    ~MCell();

public slots:

protected:
    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
    void mousePressEvent(QGraphicsSceneMouseEvent *);
    void hoverEnterEvent(QGraphicsSceneHoverEvent *);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent *);

private:
    uint m_state;
    qreal angle;
    QRect rectCell;
    bool focus;

    uint m_areaXSize;
    uint m_areaYSize;
    uint m_cellSize;

    QBrush m_cellColor;
};

#endif // MCELL_H
